#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.12.0
 Author:         Jie Shen

 Script Function:
	Utility functions

#ce ----------------------------------------------------------------------------

#include-once
#include <WinAPI.au3>

Func ActivateWindow($hWnd)
	Local $hWndPopup = 0
	While WinExists($hWnd)
		$hWndPopup = _WinAPI_GetWindow($hWnd, 6)
		If $hWndPopup = 0 Then
			$hWndPopup = $hWnd
		EndIf
		If WinActive($hWndPopup) = $hWndPopup Then
			Return $hWndPopup = $hWnd ? 1 : 2
		Else
			WinActivate($hWndPopup)
			Sleep(10)
		EndIf
	WEnd
	Return 0
EndFunc

Func ClosePopupWindows($hWnd)
	Local $hWndPopup = 0
	While WinExists($hWnd)
		$hWndPopup = _WinAPI_GetWindow($hWnd, 6)
		If $hWndPopup = $hWnd Or $hWndPopup = 0 Then
			Return True
		Else
			_WinAPI_PostMessage($hWndPopup, 0x0010, 0, 0)
			_WinAPI_PostMessage($hWndPopup, 0x0111, 0, 0)
			_WinAPI_PostMessage($hWndPopup, 0x0111, 2, 0)
			_WinAPI_PostMessage($hWndPopup, 0x0111, 7, 0)
			Sleep(10)
		EndIf
	WEnd
	Return False
EndFunc

Func RunEx($szCommand, $dwFlags, $bReturnThreadHandle = False)
	Local $strStartupInfo = DllStructCreate($tagSTARTUPINFO)
	Local $strProcInfo = DllStructCreate($tagPROCESS_INFORMATION)
	DllStructSetData($strStartupInfo, "Size", DllStructGetSize($strStartupInfo))
	If _WinAPI_CreateProcess(0, $szCommand, 0, 0, FALSE, $dwFlags, _
		0, 0, DllStructGetPtr($strStartupInfo), DllStructGetPtr($strProcInfo)) Then
		If $bReturnThreadHandle Then
			Local $hArrRet[2] = [DllStructGetData($strProcInfo, "hProcess"), _
				DllStructGetData($strProcInfo, "hThread")]
			Return $hArrRet
		Else
			_WinAPI_CloseHandle(DllStructGetData($strProcInfo, "hThread"))
			Return DllStructGetData($strProcInfo, "hProcess")
		EndIf
	Elseif $bReturnThreadHandle Then
		Local $hArrRet[2] = [0, 0]
		Return $hArrRet
	Else
		Return 0
	EndIf
EndFunc
